Results:
Loading...

JavaScript Data GridCell Editors

Create your own cell editor by providing a cell editor component.

Cell Editor

Below is an example of cell editor:
class DoublingEditor {
    init(params) {
        this.value = params.value;

        this.input = document.createElement('input');
        this.input.id = 'input';
        this.input.type = 'number';
        this.input.value = this.value;

        this.input.addEventListener('input', (event) => {
            this.value = event.target.value;
        });
    }

    /* Component Editor Lifecycle methods */
    // gets called once when grid ready to insert the element
    getGui() {
        return this.input;
    }

    // the final value to send to the grid, on completion of editing
    getValue() {
        // this simple editor doubles any value entered into the input
        return this.value * 2;
    }

    // Gets called once before editing starts, to give editor a chance to
    // cancel the editing before it even starts.
    isCancelBeforeStart() {
        return false;
    }

    // Gets called once when editing is finished (eg if Enter is pressed).
    // If you return true, then the result of the edit will be ignored.
    isCancelAfterEnd() {
        // our editor will reject any value greater than 1000
        return this.value > 1000;
    }

    // after this component has been created and inserted into the grid
    afterGuiAttached() {
        this.input.focus();
    }
}

Cell Editor Example

The example below shows a few cell editors in action.

  • The Doubling Cell Editor will double a given input and reject values over a 1000
  • The Mood Cell Editor illustrates a slightly more complicated editor with values changed depending on the smiley chosen
  • The Numeric Cell Editor illustrates a slightly more complicated numeric editor to the Doubling editor above, with increased input validation

Cell Editor Component

The interface for the cell editor component is as follows:

interface ICellEditorComp {

    // gets called once after the editor is created
    init?(params: ICellEditorParams): void;

    // Gets called once after GUI is attached to DOM.
    // Useful if you want to focus or highlight a component
    // (this is not possible when the element is not attached)
    afterGuiAttached?(): void;

    // Mandatory - Return the DOM element of your editor, this is what the grid puts into the DOM
    getGui(): HTMLElement;

    // Mandatory - Return the final value - called by the grid once after editing is complete
    getValue(): any;

    // Gets called once by grid after editing is finished
    // if your editor needs to do any cleanup, do it here
    destroy?(): void;

    // Gets called once after initialised. If you return true, the editor will
    // appear in a popup, so is not constrained to the boundaries of the cell.
    // This is great if you want to, for example, provide you own custom dropdown list
    // for selection. Default is false (ie if you don't provide the method).
    isPopup?(): boolean;

    // Gets called once, only if isPopup() returns true. Return "over" if the
    // popup should cover the cell, or "under" if it should be positioned below
    // leaving the cell value visible. If this method is not present, the
    // default is "over"
    getPopupPosition?(): string;

    // Gets called once after initialised. If you return true, the editor will not be
    // used and the grid will continue editing. Use this to make a decision on editing
    // inside the init() function, eg maybe you want to only start editing if the user
    // hits a numeric key, but not a letter, if the editor is for numbers.
    isCancelBeforeStart?(): boolean;

    // Gets called once after editing is complete. If your return true, then the new
    // value will not be used. The editing will have no impact on the record. Use this
    // if you do not want a new value from your gui, i.e. you want to cancel the editing.
    isCancelAfterEnd?(): boolean;

    // If doing full line edit, then gets called when focus should be put into the editor
    focusIn?(): boolean;

    // If doing full line edit, then gets called when focus is leaving the editor
    focusOut?(): boolean;
}

The params object provided to the init method of the cell editor has the following interface:

ICellEditorParams

Properties available on the ICellEditorParams<TData = any, TValue = any, TContext = any> interface.

Registering Cell Editors with Columns

See the section registering custom components for details on registering and using custom cell editors.

Complementing Cell Editor Params

As with cell renderers, cell editors can also be provided with additional parameters. Do this using cellEditorParams as in the following example which will pass 'Ireland' as the 'country' parameter:

colDef = {
    cellEditor: MyCellEditor,    
    cellEditorParams: {
        // make "country" value available to cell editor
        country: 'Ireland'
    },
    // ...other props
}

Configure Popup

Configure that a Custom Cell Editor is in a popup in one of the following ways:

  1. Implement the isPopup() method on the Custom Cell Editor and return true.
  2. Specify cellEditorPopup=true on the Column Definition.
colDef = {
    cellEditorPopup: true,
    // ...other props
}

Configure Popup Position

By default Popup Editors appear over the editing Cell. It is also possible to have the Cell Editor appear below the Cell, so the user can see the Cell contents while editing.

Configure the Popup Editor to appear below the Cell in one of the following ways:

  1. Implement the getPopupPosition() method on the Custom Cell Editor and return under.
  2. Specify cellEditorPopupPosition='under' on the Column Definition.
colDef = {
    cellEditorPopupPosition: 'under',
    // ...other props
}

Keyboard Navigation While Editing

If you provide a cell editor, you may wish to disable some of the grids keyboard navigation. For example, if you are providing a simple text editor, you may wish the grid to do nothing when you press the right and left arrows (the default is the grid will move to the next / previous cell) as you may want the right and left arrows to move the cursor inside your editor. In other cell editors, you may wish the grid to behave as normal.

Because different cell editors will have different requirements on what the grid does, it is up to the cell editor to decide which event it wants the grid to handle and which it does not.

You have two options to stop the grid from doing it's default action on certain key events:

  1. Stop propagation of the event to the grid in the cell editor.
  2. Tell the grid to do nothing via the colDef.suppressKeyEvent() callback.

Option 1 - Stop Propagation

If you don't want the grid to act on an event, call event.stopPropagation(). The advantage of this method is that your cell editor takes care of everything, good for creating reusable cell editors.

The follow code snippet is one you could include for a simple text editor, which would stop the grid from doing navigation.

const KEY_LEFT = 'ArrowLeft';
const KEY_UP = 'ArrowUp';
const KEY_RIGHT = 'ArrowRight';
const KEY_DOWN = 'ArrowDown';
const KEY_PAGE_UP = 'PageUp';
const KEY_PAGE_DOWN = 'PageDown';
const KEY_PAGE_HOME = 'Home';
const KEY_PAGE_END = 'End';

eInputDomElement.addEventListener('keydown', event => {
    const key = event.key;

    const isNavigationKey = key === KEY_LEFT || 
        key === KEY_RIGHT || 
        key === KEY_UP || 
        key === KEY_DOWN || 
        key === KEY_PAGE_DOWN || 
        key === KEY_PAGE_UP || 
        key === KEY_PAGE_HOME || 
        key === KEY_PAGE_END;

    if (isNavigationKey) {
        // this stops the grid from receiving the event and executing keyboard navigation
        event.stopPropagation();
    }
})

Option 2 - Suppress Keyboard Event

If you implement colDef.suppressKeyboardEvent(), you can tell the grid which events you want process and which not. The advantage of this method of the previous method is it takes the responsibility out of the cell editor and into the column definition. So if you are using a reusable, or third party, cell editor, and the editor doesn't have this logic in it, you can add the logic via configuration.

const KEY_UP = 'ArrowUp';
const KEY_DOWN = 'ArrowDown';

colDef.suppressKeyboardEvent = params => {
    console.log('cell is editing: ' + params.editing);
    console.log('keyboard event:', params.event);

    // return true (to suppress) if editing and user hit up/down keys
    const key = params.event.key;
    const gridShouldDoNothing = params.editing && (key === KEY_UP || key === KEY_DOWN);
    return gridShouldDoNothing;
}

Cell Editing Example

The example below illustrates:

  • 'Gender' column uses a Component cell editor that allows choices via a 'richSelect' (AG Grid Enterprise only), with values supplied by complementing the editor parameters.
  • 'Age' column uses a Component cell editor that allows simple integer input only.
  • 'Mood' column uses a custom Component cell editor and renderer that allows choice of mood based on image selection.
  • 'Address' column uses a Component cell editor that allows input of multiline text via a 'largeText'. Tab and Esc (amongst others) will exit editing in this field, Shift+Enter will allow newlines.
  • 'Country' columns shows using 'richSelect' for a complex object - the cell renderer takes care of only rendering the country name.

Accessing Cell Editor Instances

After the grid has created an instance of a cell editor for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the cell editor that has nothing to do with the operation of the grid. Accessing cell editors is done using the grid API getCellEditorInstances(params).

If you are doing normal editing, then only one cell is editable at any given time. For this reason if you call getCellEditorInstances() with no params, it will return back the editing cell's editor if a cell is editing, or an empty list if no cell is editing.

An example of calling getCellEditorInstances() is as follows:

const instances = gridOptions.api.getCellEditorInstances(params);
if (instances.length > 0) {
    const instance = instances[0];
}

The example below shows using getCellEditorInstances. The following can be noted:

  • All cells are editable.
  • First Name and Last Name use the default editor.
  • All other columns use the provided MySimpleCellEditor editor.
  • The example sets an interval to print information from the active cell editor. There are three results: 1) No editing 2) Editing with default cell renderer and 3) editing with the custom cell editor. All results are printed to the developer console.

React Data Grid: Cell Editors
Create your own cell editor by providing a cell editor component.
Simple Cell Editor
Below is a simple example of Cell Editor as a Hook:
const DoublingEditor = forwardRef((props, ref) => {
const [value, setValue] = useState(parseInt(props.value));
const refInput = useRef(null);
useEffect(() => {
// focus on the input
refInput.current.focus();
}, []);
/* Component Editor Lifecycle methods */
useImperativeHandle(ref, () => {
return {
// the final value to send to the grid, on completion of editing
getValue() {
// this simple editor doubles any value entered into the input
return value * 2;
},
// Gets called once before editing starts, to give editor a chance to
// cancel the editing before it even starts.
isCancelBeforeStart() {
return false;
},
// Gets called once when editing is finished (eg if Enter is pressed).
// If you return true, then the result of the edit will be ignored.
isCancelAfterEnd() {
// our editor will reject any value greater than 1000
return value > 1000;
}
};
});
return (
<input type="number"
ref={refInput}
value={value}
onChange={event => setValue(event.target.value)}
style={{width: "100%"}}
/>
);
});
And here is the same example as a Class-based Component:
export default class DoublingEditor extends Component {
constructor(props) {
super(props);
this.inputRef = createRef();
this.state = {
value: parseInt(props.value)
};
}
componentDidMount() {
this.inputRef.current.focus();
}
/* Component Editor Lifecycle methods */
// the final value to send to the grid, on completion of editing
getValue() {
// this simple editor doubles any value entered into the input
return this.state.value * 2;
}
// Gets called once before editing starts, to give editor a chance to
// cancel the editing before it even starts.
isCancelBeforeStart() {
return false;
}
// Gets called once when editing is finished (eg if Enter is pressed).
// If you return true, then the result of the edit will be ignored.
isCancelAfterEnd() {
// our editor will reject any value greater than 1000
return this.state.value > 1000;
}
render() {
return (
<input ref={this.inputRef}
value={this.state.value}
onChange={event => this.setState({value: event.target.value})}
style={{width: "100%"}}
/>
);
}
}
Simple Cell Editor Example
The example below shows a few simple cell editors in action.
- The
Doubling
Cell Editor will double a given input and reject values over a 1000 - The
Mood
Cell Editor illustrates a slightly more complicated editor with values changed depending on the smiley chosen - The
Numeric
Cell Editor illustrates a slightly more complicated numeric editor to theDoubling
editor above, with increased input validation and better initial carot behaviour
Cell Editor Component
When a React component is instantiated the grid will make the grid APIs, a number of utility methods as well as the cell &
row values available to you via props
.
The editor interface is as follows:
interface ICellEditorReactComp {
// Mandatory - Return the final value - called by the grid once after editing is complete
getValue(): any;
// Gets called once after initialised. If you return true, the editor will not be
// used and the grid will continue editing. Use this to make a decision on editing
// inside the init() function, eg maybe you want to only start editing if the user
// hits a numeric key, but not a letter, if the editor is for numbers.
isCancelBeforeStart?(): boolean;
// Gets called once after editing is complete. If your return true, then the new
// value will not be used. The editing will have no impact on the record. Use this
// if you do not want a new value from your gui, i.e. you want to cancel the editing.
isCancelAfterEnd?(): boolean;
// If doing full line edit, then gets called when focus should be put into the editor
focusIn?(): boolean;
// If doing full line edit, then gets called when focus is leaving the editor
focusOut?(): boolean;
}
Note that if you're using Hooks for Grid Components that have lifecycle/callbacks that the
grid will call (for example, the getValue
callback from an Editor Component), then you'll need to expose them with
forwardRef
& useImperativeHandle
.
Please refer to the Hook documentation (or the examples on this page) for more information.
The interface for values available on component creation (via props
) is ICellEditorParams
:
ICellEditorParams
Properties available on the ICellEditorParams
interface.
| Current value of the cell | |
| Key value of key that started the edit, eg 'Enter' or 'Delete' - non-printable characters appear here | |
| The string that started the edit, eg 'a' if letter 'a' was pressed, or 'A' if shift + letter 'a' only printable characters appear here | |
| Grid column | |
| Column definition | |
| Row node for the cell | |
| Row data | |
| Editing row index | |
| If doing full row edit, this is true if the cell is the one that started the edit (eg it is the cell the use double clicked on, or pressed a key on etc). | |
| callback to tell grid a key was pressed - useful to pass control key events (tab, arrows etc) back to grid - however you do
| |
| Callback to tell grid to stop editing the current cell. Call with input parameter true to prevent focus from moving to the next cell after editing stops in case the grid property enterMovesDownAfterEdit=true
| |
| A reference to the DOM element representing the grid cell that your component will live inside. Useful if you want to add event listeners or classes at this level. This is the DOM element that gets browser focus when selecting cells. | |
| Utility function to parse a value using the column's colDef.valueParser
| |
| Utility function to format a value using the column's colDef.valueFormatter
| |
| The grid api. | |
| The column api. | |
| Application context as set on gridOptions.context . |
Registering Cell Editors with Columns
See the section registering custom components for details on registering and using custom cell editors.
Complementing Cell Editor Params
As with cell renderers, cell editors can also be provided with additional parameters. Do this using cellEditorParams
as in the following example which will pass 'Ireland' as the 'country' parameter:
colDef = {
cellEditor: MyCellEditor,
cellEditorParams: {
// make "country" value available to cell editor
country: 'Ireland'
},
// ...other props
}
Configure Popup
Configure that an Editor is in a popup by setting cellEditorPopup=true
on the Column Definition.
colDef = {
cellEditorPopup: true,
// ...other props
}
Configure Popup Position
By default Popup Editors appear over the editing Cell. It is also possible to have the Cell Editor appear below the Cell, so the user can see the Cell contents while editing.
Configure the Popup Editor to appear below the Cell by setting cellEditorPopupPosition='under'
on the Column Definition.
colDef = {
cellEditorPopupPosition: 'under',
// ...other props
}
Keyboard Navigation While Editing
If you provide a cell editor, you may wish to disable some of the grids keyboard navigation. For example, if you are providing a simple text editor, you may wish the grid to do nothing when you press the right and left arrows (the default is the grid will move to the next / previous cell) as you may want the right and left arrows to move the cursor inside your editor. In other cell editors, you may wish the grid to behave as normal.
Because different cell editors will have different requirements on what the grid does, it is up to the cell editor to decide which event it wants the grid to handle and which it does not.
You have two options to stop the grid from doing it's default action on certain key events:
- Stop propagation of the event to the grid in the cell editor.
- Tell the grid to do nothing via the
colDef.suppressKeyEvent()
callback.
Option 1 - Stop Propagation
If you don't want the grid to act on an event, call event.stopPropagation()
. The advantage of this method is that your cell editor takes care of everything, good for creating reusable cell editors.
The follow code snippet is one you could include for a simple text editor, which would stop the grid from doing navigation.
const KEY_LEFT = 'ArrowLeft';
const KEY_UP = 'ArrowUp';
const KEY_RIGHT = 'ArrowRight';
const KEY_DOWN = 'ArrowDown';
const KEY_PAGE_UP = 'PageUp';
const KEY_PAGE_DOWN = 'PageDown';
const KEY_PAGE_HOME = 'Home';
const KEY_PAGE_END = 'End';
const MyCellEditor = forwardRef((props, ref) => {
const [value, setValue] = useState(props.value);
/* Component Editor Lifecycle methods */
useImperativeHandle(ref, () => {
return {
getValue() {
return value;
}
};
});
onKeyDown(event) {
const key = event.key;
const isNavigationKey = keyCode === KEY_LEFT ||
key === KEY_RIGHT ||
key === KEY_UP ||
key === KEY_DOWN ||
key === KEY_PAGE_DOWN ||
key === KEY_PAGE_UP ||
key === KEY_PAGE_HOME ||
key === KEY_PAGE_END;
if (isNavigationKey) {
// this stops the grid from receiving the event and executing keyboard navigation
event.stopPropagation();
}
}
return (
<input value={value}
onKeyDown={event => onKeyDown(event)}
/>
);
});
Option 2 - Suppress Keyboard Event
If you implement colDef.suppressKeyboardEvent()
, you can tell the grid which events you want process and which not. The advantage of this method of the previous method is it takes the responsibility out of the cell editor and into the column definition. So if you are using a reusable, or third party, cell editor, and the editor doesn't have this logic in it, you can add the logic via configuration.
| Allows the user to suppress certain keyboard events in the grid cell. Default: false
|
const KEY_UP = 'ArrowUp';
const KEY_DOWN = 'ArrowDown';
const GridExample = () => {
// rest of the component
const columnDefs = [
{
field: 'value',
suppressKeyboardEvent={params => {
console.log('cell is editing: ' + params.editing);
console.log('keyboard event:', params.event);
// return true (to suppress) if editing and user hit up/down keys
const key = params.event.key;
const gridShouldDoNothing = params.editing && (key === KEY_UP || key === KEY_DOWN);
return gridShouldDoNothing;
}
}
];
return (
<div
style={{
height: '100%',
width: '100%'
}}
className="ag-theme-alpine test-grid">
<AgGridReact ...rest of the definition...>
columnDefs={columnDefs}
/>
</AgGridReact>
</div>
);
};
|```
Cell Editing Example
The example below illustrates:
- 'Gender' column uses a Component cell editor that allows choices via a 'richSelect' (AG Grid Enterprise only), with values supplied by complementing the editor parameters.
- 'Age' column uses a Component cell editor that allows simple integer input only.
- 'Mood' column uses a custom Component cell editor and renderer that allows choice of mood based on image selection.
- 'Address' column uses a Component cell editor that allows input of multiline text via a 'largeText'. Tab and Esc (amongst others) will exit editing in this field, Shift+Enter will allow newlines.
- 'Country' columns shows using 'richSelect' for a complex object - the cell renderer takes care of only rendering the country name.
Accessing Cell Editor Instances
After the grid has created an instance of a cell editor for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the cell editor that has nothing to do with the operation of the grid. Accessing cell editors is done using the grid API getCellEditorInstances(params)
.
| Returns the list of active cell editor instances. Optionally provide parameters to restrict to certain columns / row nodes. |
If you are doing normal editing, then only one cell is editable at any given time. For this reason if you call getCellEditorInstances()
with no params, it will return back the editing cell's editor if a cell is editing, or an empty list if no cell is editing.
An example of calling getCellEditorInstances()
is as follows:
const instances = gridOptions.api.getCellEditorInstances(params);
if (instances.length > 0) {
const instance = instances[0];
}
The example below shows using getCellEditorInstances
. The following can be noted:
- All cells are editable.
- First Name and Last Name use the default editor.
- All other columns use the provided
MySimpleCellEditor
editor. - The example sets an interval to print information from the active cell editor. There are three results: 1) No editing 2) Editing with default cell renderer and 3) editing with the custom cell editor. All results are printed to the developer console.
- Cell Editors
- Simple Cell Editor
- Simple Cell Editor Example
- Cell Editor Component
- Cell Editor Component
- Cell Editor Component
- Cell Editor Component
- Vue 3 - Class Based Components & Typed Components
- Registering Cell Editors with Columns
- Complementing Cell Editor Params
- Configure Popup
- Configure Popup Position
- Keyboard Navigation While Editing
- Option 1 - Stop Propagation
- Option 2 - Suppress Keyboard Event
- Cell Editing Example
- Accessing Cell Editor Instances

What's new webinar: AG Grid 36 and AG Charts 14 Join us for a webinar on 14th July at 2pm UTC+1 Register




Core Features

Advanced Features

Angular Data GridEdit Components

A Cell Editor Component is the UI that appears, normally inside the Cell, that takes care of the Edit operation. You can select from the Provided Cell Editors or create your own Custom Cell Editor Components.

The example below shows some Provided Editor Components and some Custom Editor Components.

Custom Components Copy Link

To create a custom cell editor, implement the ICellEditorAngularComp interface, which defines two mandatory methods:

  • agInit(params: ICellEditorParams) - called when the editor is initialised
  • getValue() - called by the grid to get the final value when editing is complete.

Full details of the ICellEditorAngularComp and ICellEditorParams interfaces are listed below under API Reference.

Selecting Components Copy Link

Cell Editor Components are configured using the cellEditor property of the Column Definition.

cellEditorCopy Link
any
Provide your own cell editor component for this column's cells.
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'name',
        editable: true,
        // uses a provided editor, referenced by name
        cellEditor: 'agTextCellEditor'
    },
    {
        field: 'name',
        editable: true,
        // uses a custom editor, referenced directly
        cellEditor: 'CustomEditorComp'
    },
];

See Registering Custom Components for details on how to register your custom grid components.

Dynamic Selection Copy Link

The colDef.cellEditorSelector function allows setting different Editor Components for different Rows within a Column.

cellEditorSelectorCopy Link
CellEditorSelectorFunc
Callback to select which cell editor to be used for a given row within the same column.

The params passed to cellEditorSelector are the same as those passed to the Editor Component. Typically the selector will use this to check the row's contents and choose an editor accordingly.

The result is an object with component and params to use instead of cellEditor and cellEditorParams.

This following shows the Selector always returning back the provided Rich Select Editor:

cellEditorSelector: params => {
    return {
        component: 'agRichSelectCellEditor',
        params: { values: ['Male', 'Female'] }
    };
}

However a selector only makes sense when a selection is made. The following demonstrates selecting between Cell Editors:

cellEditorSelector: params => {

  if (params.data.type === 'age') {
    return {
      component: NumericCellEditor,
    }
  }

  if (params.data.type === 'gender') {
    return {
      component: 'agRichSelectCellEditor',
      params: {
        values: ['Male', 'Female']
      }
    }
  }

  if (params.data.type === 'mood') {
    return {
      component: MoodEditor,
      popup: true,
      popupPosition: 'under'
    }
  }

  return undefined
}

Here is a full example:

  • The column 'Value' holds data of different types as shown in the column 'Type' (numbers/genders/moods).
  • colDef.cellEditorSelector is a function that returns the name of the component to use to edit based on the type of data for that row
  • Edit a cell by double clicking to observe the different editors used.

Custom Props Copy Link

The property colDef.cellEditorParams allows custom props to be passed to editors.

cellEditorParamsCopy Link
any
Params to be passed to the cellEditor component.
colDef = {
    cellEditor: MyCellEditor,
    cellEditorParams: {
        // make "country" value available to cell editor
        country: 'Ireland'
    },
    // ...other props
}

Dynamic Props Copy Link

The colDef.cellEditorParams function allows dynamic props independently of the Editor selection. For example you might have a 'City' column that has values based on the 'Country' column.

cellEditorParams: params => {
    const selectedCountry = params.data.country;

    if (selectedCountry === 'Ireland') {
        return {
            values: ['Dublin', 'Cork', 'Galway']
        };
    } else {
        return {
            values: ['New York', 'Los Angeles', 'Chicago', 'Houston']
        };
    }
}

Below shows an example with dynamic props. The following can be noted:

  • Column Gender uses a Cell Component for both the grid and the editor.
  • Column Country allows country selection, with cellHeight being used to make each entry 50px tall. If the currently selected city for the row doesn't match a newly selected country, the city cell is cleared.
  • Column City uses dynamic parameters to display values for the selected country, and uses formatValue to add the selected city's country as a suffix.
  • Column Address uses the large text area editor.

An editor can be Inline or Popup.

An Inline Editor Component will be placed inside the Grid's Cell, replacing the Cell contents when active.

A Popup Editor Component appears in a popup over the Cell. Popup Editors are not constrained to the Cells dimensions.

Configure that a Custom Cell Editor is in a popup in one of the following ways:

  1. Specify cellEditorPopup=true on the Column Definition.
  2. Implement the isPopup() method on the Custom Cell Editor and return true.
colDefs = [
  {
    cellEditor: MyPopupEditor,
    cellEditorPopup: true
    // ...
  }
]

Popup Editors appear over the editing Cell. Configure the Popup Editor to appear below the Cell in one of the following ways:

  1. Implement the getPopupPosition() method on the Custom Cell Editor and return under.
  2. Specify cellEditorPopupPosition='under' on the Column Definition.
colDef = {
  cellEditorPopup: true,
  cellEditorPopupPosition: 'under',
  // ...other props
}

The following example demonstrates the same editor positioned inline, as a popup over the cell, and as a popup under the cell:

If a custom cell editor creates its own popup that is anchored outside of the editor component (e.g. like a third-party date picker), then the popup element needs to have the 'ag-custom-component-popup' CSS class. This allows the grid to determine correctly when to stop editing.

Keyboard Navigation Copy Link

In Custom Editors, you may wish to disable some of the Grids keyboard navigation. For example, if you are providing a simple text editor, you may wish the grid to do nothing when you press the right and left arrows (the default is the grid will move to the next / previous cell) as you may want the right and left arrows to move the cursor inside your editor. In other cell editors, you may wish the grid to behave as normal.

Because different cell editors will have different requirements on what the grid does, it is up to the cell editor to decide which event it wants the grid to handle and which it does not.

You have two options to stop the grid from doing it's default action on certain key events:

  1. Stop propagation of the event to the grid in the cell editor.
  2. Tell the grid to do nothing via the colDef.suppressKeyboardEvent() callback.

Option 1 - Stop Propagation Copy Link

If you don't want the grid to act on an event, call event.stopPropagation(). The advantage of this method is that your cell editor takes care of everything, this is good for creating reusable cell editors.

The following code snippet is one you could include for a simple text editor, which would stop the grid from doing navigation.

const KEY_LEFT = 'ArrowLeft';
const KEY_UP = 'ArrowUp';
const KEY_RIGHT = 'ArrowRight';
const KEY_DOWN = 'ArrowDown';
const KEY_PAGE_UP = 'PageUp';
const KEY_PAGE_DOWN = 'PageDown';
const KEY_PAGE_HOME = 'Home';
const KEY_PAGE_END = 'End';

@Component({
    selector: 'my-editor',
    template: `<input (keydown)="onKeyDown($event)" ...rest of input/>`
})
export class MyCellEditor implements ICellEditorAngularComp {
    /* Component Editor Lifecycle method */
    agInit(params: ICellEditorParams) {
        this.params = params;
    }

    onKeyDown(event) {
        const key = event.key;

        const isNavigationKey = key === KEY_LEFT ||
            key === KEY_RIGHT ||
            key === KEY_UP ||
            key === KEY_DOWN ||
            key === KEY_PAGE_DOWN ||
            key === KEY_PAGE_UP ||
            key === KEY_PAGE_HOME ||
            key === KEY_PAGE_END;

            if (isNavigationKey) {
                // this stops the grid from receiving the event and executing keyboard navigation
                event.stopPropagation();
            }
    }

    // ..rest of the component
}

Option 2 - Suppress Keyboard Event Copy Link

If you implement colDef.suppressKeyboardEvent(), you can tell the grid which events you want to process and which not. The advantage of this method of the previous method is it takes the responsibility out of the cell editor and into the column definition. So if you are using a reusable, or third party, cell editor, and the editor doesn't have this logic in it, you can add the logic via configuration.

suppressKeyboardEventCopy Link
SuppressKeyboardEventFunc
default: false
Allows the user to suppress certain keyboard events in the grid cell.
const KEY_UP = 'ArrowUp';
const KEY_DOWN = 'ArrowDown';

@Component({
    selector: 'my-grid',
    template: `
        <ag-grid-angular
            [columnDefs]="columnDefs"
            ...rest of the component... />
    `
})
export class AppComponent {
    columnDefs = [
        {
            headerName: "Value Column",
            field: "value",
            suppressKeyboardEvent: params => {
                console.log('cell is editing: ' + params.editing);
                console.log('keyboard event:', params.event);

                // return true (to suppress) if editing and user hit up/down keys
                const key = params.event.key;
                const gridShouldDoNothing = params.editing && (key === KEY_UP || key === KEY_DOWN);
                return gridShouldDoNothing;
            }
        }
    ]

    ...rest of the component...
}

Accessing Instances Copy Link

After the grid has created an instance of an Editor Component for a Cell it is possible to access that instance. This is useful if you want to call a method that you provide on the Editor that has nothing to do with the operation of the grid. Accessing Editors is done using the grid API getCellEditorInstances(params).

getCellEditorInstancesCopy Link
Function
Returns the list of active cell editor instances. Optionally provide parameters to restrict to certain columns / row nodes.

If you are doing normal editing, then only one cell is editable at any given time. For this reason if you call getCellEditorInstances() with no params, it will return back the editing cell's editor if a cell is editing, or an empty list if no cell is editing.

An example of calling getCellEditorInstances() is as follows:

const instances = api.getCellEditorInstances(params);
if (instances.length > 0) {
    const instance = instances[0];
}

The example below shows using getCellEditorInstances. The following can be noted:

  • All cells are editable.
  • First Name and Last Name use the default editor.
  • All other columns use the provided MySimpleCellEditor editor.
  • The example sets an interval to print information from the active cell editor. There are three results: 1) No editing 2) Editing with default cell renderer and 3) editing with the custom cell editor. All results are printed to the developer console.

API Reference Copy Link

ICellEditorAngularComp Copy Link

The ICellEditorAngularComp interface has the following methods:

agInitCopy Link
Function
Mandatory - Params for rendering this component.
getValueCopy Link
Function
Mandatory - Return the final value. Called by the grid once after editing is complete.
refreshCopy Link
Function
Optional: Gets called with the latest cell editor params every time they update
afterGuiAttachedCopy Link
Function
Optional: A hook to perform any necessary operation just after the GUI for this component has been rendered on the screen. This method is called each time the edit component is activated. This is useful for any logic that requires attachment before executing, such as putting focus on a particular DOM element.
isPopupCopy Link
Function
Optional: Gets called once after initialised. If you return true, the editor will appear in a popup, so is not constrained to the boundaries of the cell. This is great if you want to, for example, provide you own custom dropdown list for selection. Default is false (ie if you don't provide the method).
getPopupPositionCopy Link
Function
Optional: Gets called once, only if isPopup() returns true. Return "over" if the popup should cover the cell, or "under" if it should be positioned below leaving the cell value visible. If this method is not present, the default is "over".
isCancelBeforeStartCopy Link
Function
Optional: Gets called once after initialised. If you return true, the editor will not be used and the grid will continue editing. Use this to make a decision on editing inside the init() function, eg maybe you want to only start editing if the user hits a numeric key, but not a letter, if the editor is for numbers.
isCancelAfterEndCopy Link
Function
Optional: Gets called once after editing is complete. If your return true, then the new value will not be used. The editing will have no impact on the record. Use this if you do not want a new value from your gui, i.e. you want to cancel the editing.
focusInCopy Link
Function
Optional: If doing full line edit, then gets called when focus should be put into the editor
focusOutCopy Link
Function
Optional: If doing full line edit, then gets called when focus is leaving the editor
getValidationElementCopy Link
Function
Optional: Returns the element to use for validation feedback. Called by the grid in two contexts:
  • tooltip: true → used as the anchor for validation tooltips.
  • tooltip: false → receives the invalid CSS class for visual feedback.
  • If omitted, the grid falls back to the cell element for inline editors. Popup editors that do not implement this will not show validation styles or tooltips. tooltip - Whether the element is for a tooltip or direct styling.
    Returns: An HTML element for feedback, or null/undefined to use default behavior.
    getValidationErrorsCopy Link
    Function
    Optional: The error messages associated with the Editor

    ICellEditorParams Copy Link

    Properties available on the ICellEditorParams<TData = any, TValue = any, TContext = any> interface.

    parseValueCopy Link
    Function
    Utility function to parse a value using the column's colDef.valueParser
    formatValueCopy Link
    Function
    Utility function to format a value using the column's colDef.valueFormatter
    Current value of the cell
    eventKeyCopy Link
    string | null
    Key value of key that started the edit, eg 'Enter' or 'F2' - non-printable characters appear here
    Grid column
    Column definition
    Row node for the cell
    Row data
    rowIndexCopy Link
    number
    Editing row index
    cellStartedEditCopy Link
    boolean
    If doing full row edit, this is true if the cell is the one that started the edit (eg it is the cell the use double clicked on, or pressed a key on etc).
    onKeyDownCopy Link
    Function
    callback to tell grid a key was pressed - useful to pass control key events (tab, arrows etc) back to grid - however you do
    stopEditingCopy Link
    Function
    Callback to tell grid to stop editing the current cell. Call with input parameter true to prevent focus from moving to the next cell after editing stops in case the grid property enterNavigatesVerticallyAfterEdit=true
    A reference to the DOM element representing the grid cell that your component will live inside. Useful if you want to add event listeners or classes at this level. This is the DOM element that gets browser focus when selecting cells.
    getValidationErrorsCopy Link
    Function
    Optional validation callback that will override the getValidationErrors() of Provided Editors. Use this to return your own custom errors.
    Returns: An array of strings containing the editor error messages, or null if the editor is valid.
    validateCopy Link
    Function
    Runs the Editor Validation.
    The grid api.
    Application context as set on gridOptions.context.

Results:
Loading...

Vue Data GridCell Editors

Create your own cell editor by providing a cell editor component.

Cell Editor

Below is an example of cell editor:
const DoublingEditor = {
    template: `<input type="number" v-model="value" ref="input" style="width: 100%" />`,
    data() {
        return {
            value: null
        };
    },
    methods: {
        /* Component Editor Lifecycle methods */
        // the final value to send to the grid, on completion of editing
        getValue() {
            // this simple editor doubles any value entered into the input
            return this.value * 2;
        },

        // Gets called once before editing starts, to give editor a chance to
        // cancel the editing before it even starts.
        isCancelBeforeStart() {
            return false;
        },

        // Gets called once when editing is finished (eg if Enter is pressed).
        // If you return true, then the result of the edit will be ignored.
        isCancelAfterEnd() {
            // our editor will reject any value greater than 1000
            return this.value > 1000;
        }
    },
    mounted() {
        this.value = this.params.value;
        Vue.nextTick(() => this.$refs.input.focus());
    }
}

And here is the same cell editor using Vue 3's Composition API:

export default {
     template: `<input type="number" v-model="value" ref="input" style="width: 100%"/>`,
     setup(props) {
         // the current/initial value of the cell (before editing)
         const value = ref(props.params.value);
 
         /* Component Editor Lifecycle methods */
         // the final value to send to the grid, on completion of editing
         const getValue = () => {
             // this simple editor doubles any value entered into the input
             return value.value * 2;
         };
 
         // Gets called once before editing starts, to give editor a chance to
         // cancel the editing before it even starts.
         const isCancelBeforeStart = () => {
             return false;
         };
 
         // Gets called once when editing is finished (eg if Enter is pressed).
         // If you return true, then the result of the edit will be ignored.
         const isCancelAfterEnd = () => {
             // our editor will reject any value greater than 1000
             return value.value > 1000;
         };
 
         return {
             value,
             getValue,
             isCancelBeforeStart,
             isCancelAfterEnd
         }
     },
     mounted() {
         // focus on the input field once editing starts
         nextTick(() => this.$refs.input.focus());
     }
 };

Cell Editor Example

The example below shows a few cell editors in action.

  • The Doubling Cell Editor will double a given input and reject values over a 1000
  • The Mood Cell Editor illustrates a slightly more complicated editor with values changed depending on the smiley chosen
  • The Numeric Cell Editor illustrates a slightly more complicated numeric editor to the Doubling editor above, with increased input validation

Cell Editor Component

When a Vue component is instantiated the grid will make the grid APIs, a number of utility methods as well as the cell and row values available to you via a params object.

With Vue 2 and Vue 3 you can access the params object via this.params in the usual methods (lifecycle hooks, methods etc), and with Vue 3's setup via props.params.

The editor params interface is as follows:

ICellEditorParams

Properties available on the ICellEditorParams<TData = any, TValue = any, TContext = any> interface.

Vue 3 - Class Based Components & Typed Components

If you're using a Class Based Component (i.e. you're using vue-property-decorator/vue-class-component), or if you're using a vanilla Vue 3 component with lang='ts' then you'll need to specify the params object as a prop.

For example:

<script lang="ts">
    import {defineComponent} from "vue";

    export default defineComponent({
        name: "MyComponent",
        props: ['params'],  // required for TypeScript ...
    })
</script>

Registering Cell Editors with Columns

See the section registering custom components for details on registering and using custom cell editors.

Complementing Cell Editor Params

As with cell renderers, cell editors can also be provided with additional parameters. Do this using cellEditorParams as in the following example which will pass 'Ireland' as the 'country' parameter:

colDef = {
    cellEditor: 'MyCellEditor',    
    cellEditorParams: {
        // make "country" value available to cell editor
        country: 'Ireland'
    },
    // ...other props
}

Configure Popup

Configure that a Custom Cell Editor is in a popup in one of the following ways:

  1. Implement the isPopup() method on the Custom Cell Editor and return true.
  2. Specify cellEditorPopup=true on the Column Definition.
colDef = {
    cellEditorPopup: true,
    // ...other props
}

Configure Popup Position

By default Popup Editors appear over the editing Cell. It is also possible to have the Cell Editor appear below the Cell, so the user can see the Cell contents while editing.

Configure the Popup Editor to appear below the Cell in one of the following ways:

  1. Implement the getPopupPosition() method on the Custom Cell Editor and return under.
  2. Specify cellEditorPopupPosition='under' on the Column Definition.
colDef = {
    cellEditorPopupPosition: 'under',
    // ...other props
}

Keyboard Navigation While Editing

If you provide a cell editor, you may wish to disable some of the grids keyboard navigation. For example, if you are providing a simple text editor, you may wish the grid to do nothing when you press the right and left arrows (the default is the grid will move to the next / previous cell) as you may want the right and left arrows to move the cursor inside your editor. In other cell editors, you may wish the grid to behave as normal.

Because different cell editors will have different requirements on what the grid does, it is up to the cell editor to decide which event it wants the grid to handle and which it does not.

You have two options to stop the grid from doing it's default action on certain key events:

  1. Stop propagation of the event to the grid in the cell editor.
  2. Tell the grid to do nothing via the colDef.suppressKeyEvent() callback.

Option 1 - Stop Propagation

If you don't want the grid to act on an event, call event.stopPropagation(). The advantage of this method is that your cell editor takes care of everything, good for creating reusable cell editors.

The follow code snippet is one you could include for a simple text editor, which would stop the grid from doing navigation.

const KEY_LEFT = 'ArrowLeft';
const KEY_UP = 'ArrowUp';
const KEY_RIGHT = 'ArrowRight';
const KEY_DOWN = 'ArrowDown';
const KEY_PAGE_UP = 'PageUp';
const KEY_PAGE_DOWN = 'PageDown';
const KEY_PAGE_HOME = 'Home';
const KEY_PAGE_END = 'End';

const MyCellEditor = {
    template: `<input v-model="value" @keydown="onKeyDown" />`,
    data() {
        return {
            value: null
        };
    },
    methods: {
        /* Component Editor Lifecycle method */
        getValue() {
            return this.value;
        },
        
        onKeyDown(event) {
           const key = event.key;

           const isNavigationKey = key === KEY_LEFT ||
               key === KEY_RIGHT ||
               key === KEY_UP ||
               key === KEY_DOWN ||
               key === KEY_PAGE_DOWN ||
               key === KEY_PAGE_UP ||
               key === KEY_PAGE_HOME ||
               key === KEY_PAGE_END;

               if (isNavigationKey) {
                   // this stops the grid from receiving the event and executing keyboard navigation
                   event.stopPropagation();
               }
        }
    },
    mounted() {
        this.value = this.params.value;
    }
}

Option 2 - Suppress Keyboard Event

If you implement colDef.suppressKeyboardEvent(), you can tell the grid which events you want process and which not. The advantage of this method of the previous method is it takes the responsibility out of the cell editor and into the column definition. So if you are using a reusable, or third party, cell editor, and the editor doesn't have this logic in it, you can add the logic via configuration.

const KEY_UP = 'ArrowUp';
const KEY_DOWN = 'ArrowDown';

const MyGrid = {
    template: `
       <ag-grid-vue
           class="ag-theme-alpine"
           :columnDefs="columnDefs">
       </ag-grid-vue>
    `,
    components: {
        'ag-grid-vue': AgGridVue
    },
    data: function () {
        return {
            columnDefs: [
               {
                   headerName: "Value Column",
                   field: "value",
                   suppressKeyboardEvent: params => {
                       console.log('cell is editing: ' + params.editing);
                       console.log('keyboard event:', params.event);
                
                       // return true (to suppress) if editing and user hit up/down keys
                       const key = params.event.key;
                       const gridShouldDoNothing = params.editing && (key === KEY_UP || key === KEY_DOWN);
                       return gridShouldDoNothing;
                   }
               }
            ]
        }
    },

    // rest of the component
}

Cell Editing Example

The example below illustrates:

  • 'Gender' column uses a Component cell editor that allows choices via a 'richSelect' (AG Grid Enterprise only), with values supplied by complementing the editor parameters.
  • 'Age' column uses a Component cell editor that allows simple integer input only.
  • 'Mood' column uses a custom Component cell editor and renderer that allows choice of mood based on image selection.
  • 'Address' column uses a Component cell editor that allows input of multiline text via a 'largeText'. Tab and Esc (amongst others) will exit editing in this field, Shift+Enter will allow newlines.
  • 'Country' columns shows using 'richSelect' for a complex object - the cell renderer takes care of only rendering the country name.

Accessing Cell Editor Instances

After the grid has created an instance of a cell editor for a cell it is possible to access that instance. This is useful if you want to call a method that you provide on the cell editor that has nothing to do with the operation of the grid. Accessing cell editors is done using the grid API getCellEditorInstances(params).

If you are doing normal editing, then only one cell is editable at any given time. For this reason if you call getCellEditorInstances() with no params, it will return back the editing cell's editor if a cell is editing, or an empty list if no cell is editing.

An example of calling getCellEditorInstances() is as follows:

const instances = gridOptions.api.getCellEditorInstances(params);
if (instances.length > 0) {
    const instance = instances[0];
}

The example below shows using getCellEditorInstances. The following can be noted:

  • All cells are editable.
  • First Name and Last Name use the default editor.
  • All other columns use the provided MySimpleCellEditor editor.
  • The example sets an interval to print information from the active cell editor. There are three results: 1) No editing 2) Editing with default cell renderer and 3) editing with the custom cell editor. All results are printed to the developer console.